<?php
/*********************************************************************
*    Description	:	Class for User page
*    Developer	:	Min (min@minstory.kr / 010.3597.2794)
*    Date			:	2012. 05. 15
*    Have a nice day, Good Luck to you ^^/
*********************************************************************/
class M_ACCOUNT {
	public $status_arr;

	function __construct() {	
		global $Level_Info;
		global $M_FUNC;

		if($_SESSION["Language"] == 1) {
			$this->status_arr = array (
				1 => "Enable",
				2 => "Disable"
			);
			$this->advertiserType_arr = array (
				1 => "법인사업자",
				2 => "개인사업자"
			);
		} else {
			$this->status_arr = array (
				1 => "Use",
				2 => "I do not use"
			);
			$this->advertiserType_arr = array (
				1 => "Corporation",
				2 => "Individual enterpriser"
			);
		}
		$this->level_arr = $Level_Info;
	}

	function __destruct() {
	}
	
	/*** Account Manage ***/
	function checkAccountID() {
		global $db, $M_FUNC;
		
		$accountID	 = $M_FUNC->M_Filter(GET, "accountID");
		$query = " SELECT * FROM ". ACCOUNT_TABLE . " WHERE accountID = '". $accountID ."' ";
		$row = $db->getListSet($query);
		if ($row->size() > 0) {
			return false;
		} else {
			return true;
		}
	}

	function getAccountList(&$total_page, &$NO, &$cnt_no, $addWhere = null, $order = null, $limit = null) {
		global $db, $M_FUNC;
		global $PAGE;

		if ($PAGE < 1 or $PAGE == "") $PAGE = 1;
		$start_row = ($PAGE - 1) * C_LIST_CNT;
		$where = " WHERE status != 99 and level in(1,2) ";
		if ($addWhere) {
			$where .= $addWhere;
		}
		
		if ($order == "") {
			//$orderQuery = " ORDER BY idx DESC ";
			$orderQuery = "";
		} else {
			$orderQuery = " ORDER BY ". $order;
		}
		
		if ($limit == "NO") {
			$limitQuery = "";
		} else {
			$limitQuery = " LIMIT ". $start_row .", ". C_LIST_CNT;
		}

		$query = " SELECT * "
					. " FROM ". ACCOUNT_TABLE
					. $where
					. $orderQuery
					. $limitQuery;
		$row = $db->getListSet($query);

		$cnt_no = $db->cnt(ACCOUNT_TABLE, $where);
		$total_page = (int)(($cnt_no - 1) / C_LIST_CNT) + 1;
		$NO = $cnt_no - $start_row;
		
		return $row;
	}

	function getAccountInfoByIdx($idx, $field = null) {
		global $db, $M_FUNC;

		$query = " SELECT  * FROM " 
					.  ACCOUNT_TABLE
					. " WHERE idx = ". $idx ." AND status <> 99 ";
		$row = $db->getListSet($query);

		$row->next();

		if ($field) {
			return $row->get($field);
		} else {
			return $row;
		}
	}

	function getAccountIdArr(){
		global $db, $M_FUNC;
		
		$result = array();

		$query = " SELECT * "
					. " FROM " . ACCOUNT_TABLE
					. " WHERE 1=1 and status <> 99 ";

		$row = $db->getListSet($query);
		for($i=0; $i<$row->size(); $i++){
			$row->next();
			$result[$row->get('idx')] = $row->get('accountID');
		}

		return $result;
	}

	function insertAccountData() {
		global $db, $M_FUNC, $M_CRUMB, $M_JS, $_SESSION, $M_FILE, $M_MEMBER;
		global $MENU_ID;

		/*** Check Crumb ***/
		$m_crumb = $_SESSION["m_crumb"];
		$M_CRUMB->checkCrumb($m_crumb);
		$_SESSION["m_crumb"] = null;

		$accountID			= $M_FUNC->M_Filter(POST, "accountID");
		$accountPW			= $M_FUNC->M_Filter(POST, "accountPW");
		$accountName		= $M_FUNC->M_Filter(POST, "accountName");
		$level					= $M_FUNC->M_Filter(POST, "level");
		$permission			= $M_FUNC->M_Filter(POST, "permission");
		$roleIdx				= $M_FUNC->M_Filter(POST, "roleIdx");
		$status				= $M_FUNC->M_Filter(POST, "status");
		/*** Check userID ***/
		$cnt = $db->cnt(ACCOUNT_TABLE, "WHERE accountID = '". $accountID ."'");
		if ($cnt > 0) {
			$M_JS->alert("This ID is already in use. Please write another ID.");
			exit;
		}

		if (!$permission) {
			$permission = 1;
		}
		
		$data = array(
			'accountID'			=> $accountID,
			'accountPW'			=> md5($accountPW),
			'accountName'		=> $accountName,
			'level'					=> $level,
			'regUnixtime'		=> time(),
			'permission'			=> $permission,
			'status'					=> $status,
		);
		$db->insert(ACCOUNT_TABLE, $data);
		$accountIdx = $db->getLastIdx("idx", ACCOUNT_TABLE);

		return $accountIdx;
	}

	function updateAccountData() {
		global $db, $M_FUNC, $M_CRUMB, $M_JS, $_SESSION, $M_FILE, $MENU_ID;

		/*** Check Crumb ***/
		$m_crumb = $_SESSION["m_crumb"];
		$M_CRUMB->checkCrumb($m_crumb);
		$_SESSION["m_crumb"] = null;

		$idx						= $M_FUNC->M_Filter(POST, "m_id");
		$accountPW			= $M_FUNC->M_Filter(POST, "accountPW");
		$accountName		= $M_FUNC->M_Filter(POST, "accountName");
		$level					= $M_FUNC->M_Filter(POST, "level");
		$permission			= $M_FUNC->M_Filter(POST, "permission");
		$isResetPW			= $M_FUNC->M_Filter(POST, "isResetPW");
		$roleIdx				= $M_FUNC->M_Filter(POST, "roleIdx");
		$status				= $M_FUNC->M_Filter(POST, "status");

		if (!$permission) {
			$permission = 1;
		}

		$data = array(
			'accountName'		=> $accountName,
			'level'					=> $level,
			'permission'		=> $permission,
			'status'				=> $status,
		);

		if ($isResetPW == "Y") {
			$data = array_merge($data, array ( 'accountPW' => md5($accountPW) ));
		}
		$where = " WHERE idx = ". $idx;
		$db->update(ACCOUNT_TABLE, $data, $where);
	}

	function getLinkSlotAndTemplate($SI_idx) {
		global $db, $M_FUNC, $M_CRUMB, $M_JS, $_SESSION, $M_FILE, $MENU_ID;

		$query = " SELECT * FROM Slot_Template_Link WHERE SI_idx = ". $SI_idx;
		$row = $db->getListSet($query);
		return $row;
	}

	/*** Advertiser manage ***/
	function getAdvertiserRow(&$total_page, &$NO, &$cnt_no, $addWhere = null, $order = null, $limit = null) {
		global $db, $M_FUNC, $M_MEMBER;
		global $PAGE;

		if ($PAGE < 1 or $PAGE == "") $PAGE = 1;
		$start_row = ($PAGE - 1) * C_LIST_CNT;
		$where = " ad.keyAccountIdx=ai.idx WHERE ad.status <> 99  and ai.level = 41 ";

		if ($addWhere) {
			$where .= $addWhere;
		}

		if ($limit == "NO") {
			$limitQuery = "";
		} else {
			$limitQuery = " LIMIT ". $start_row .", ". C_LIST_CNT;
		}

		if ($order == "") {
			//$orderQuery = " ORDER BY idx DESC ";
			$orderQuery = "";
		} else {
			$orderQuery = " ORDER BY ". $order;
		}

		$this->table = ADVERTISER_TABLE . " ad INNER JOIN " . ACCOUNT_TABLE . " ai on ";

		$query = " SELECT ad.idx as idx, ad.advertiserName, ad.regUnixtime as regUnixtime, ad.status as status, ad.keyAccountIdx as keyAccountIdx "
					. " FROM ". $this->table
					. $where
					. $orderQuery
					. $limitQuery;
		$row = $db->getListSet($query);

		$cnt_no = $db->cnt($this->table, $where);
		$total_page = (int)(($cnt_no - 1) / C_LIST_CNT) + 1;
		$NO = $cnt_no - $start_row;
		
		return $row;
	}

	function getAdvertiserInfoByIdx($idx, $field = null) {
		global $db, $M_FUNC;

		$query = " SELECT * FROM "
					. ADVERTISER_TABLE
					. " WHERE idx = ". $idx . " AND status <> 99 ";
		$row = $db->getListSet($query);
		$row->next();

		if ($field) {
			return $row->get($field);
		} else {
			return $row;
		}
	}

	function insertAdvertiserData() {
		global $db, $M_FUNC, $M_CRUMB, $M_JS, $_SESSION, $M_FILE, $M_MEMBER;
		global $MENU_ID;

		/*** Check Crumb ***/
		$m_crumb = $_SESSION["m_crumb"];
		$M_CRUMB->checkCrumb($m_crumb);
		$_SESSION["m_crumb"] = null;

		$advertiserName					= $M_FUNC->M_Filter(POST, "advertiserName");
		$status								= $M_FUNC->M_Filter(POST, "status");

		$accountID							= $M_FUNC->M_Filter(POST, "accountID");
		$accountPW							= $M_FUNC->M_Filter(POST, "accountPW");
		$accountName						= $advertiserName;
		$level									= 41;
		$permission							= 2;

		/*** Check userID ***/
		$cnt = $db->cnt(ACCOUNT_TABLE, "WHERE accountID = '". $accountID ."'");
		if ($cnt > 0) {
			$M_JS->alert("This ID is already in use. Please write another ID.");
			exit;
		}
		
		$data = array(
			'accountID'			=> $accountID,
			'accountPW'			=> md5($accountPW),
			'accountName'		=> $accountName,
			'level'					=> $level,
			'regUnixtime'		=> time(),
			'permission'			=> $permission,
			'status'					=> $status,
		);

		$db->insert(ACCOUNT_TABLE, $data);
		$accountIdx = $db->getLastIdx("idx", ACCOUNT_TABLE);
		$data = array(
			'advertiserName'			=> $advertiserName,
			'regUnixtime'					=> time(),
			'keyAccountIdx'				=> $accountIdx,
			'status'							=> $status,
		);

		$db->insert(ADVERTISER_TABLE, $data);
		$advertiserIdx = $db->getLastIdx("idx", ADVERTISER_TABLE);
		if ($level >= 11) {
			$data = array (
				'accountIdx'	=> $accountIdx,
				'roleIdx'			=> $advertiserIdx,
				'level'			=> $level
			);
			$db->insert(ACCOUNT_ROLE_TABLE, $data);
		}

		return $advertiserIdx;
	}

	function updateAdvertiserData() {
		global $db, $M_FUNC, $M_CRUMB, $M_JS, $_SESSION, $M_FILE, $MENU_ID;

		/*** Check Crumb ***/
		$m_crumb = $_SESSION["m_crumb"];
		$M_CRUMB->checkCrumb($m_crumb);
		$_SESSION["m_crumb"] = null;

		$idx										= $M_FUNC->M_Filter(POST, "m_id");
		$advertiserName					= $M_FUNC->M_Filter(POST, "advertiserName");
		$URL									= $M_FUNC->M_Filter(POST, "URL");
		$status								= $M_FUNC->M_Filter(POST, "status");
		$keyAccountIdx					= $M_FUNC->M_Filter(POST, "keyAccountIdx");
		$isResetPW							= $M_FUNC->M_Filter(POST, "isResetPW");
		$accountPW							= $M_FUNC->M_Filter(POST, "accountPW");

		$data = array(
			'advertiserName'				=> $advertiserName,
			'status'								=> $status
		);

		$this->table = ADVERTISER_TABLE;
		$where = " WHERE idx = ". $idx;
		$db->update($this->table, $data, $where);

		$accountName = $this->getAccountInfoByIdx($keyAccountIdx,"accountName");
		if($advertiserName != $accountName){
			$data = array ( 'accountName' => $advertiserName);
			$where = " WHERE idx = ". $keyAccountIdx;
			$db->update(ACCOUNT_TABLE, $data, $where);	
		}

		if ($isResetPW == "Y") {
			$data = array ( 'accountPW' => md5($accountPW) );
			$where = " WHERE idx = ". $keyAccountIdx;
			$db->update(ACCOUNT_TABLE, $data, $where);
		}
	}

	function getUserInfoByAccountIdx($idx, $field = null) {
		global $db, $M_FUNC;

		$query = " SELECT * "
					. " FROM ". USER_TABLE
					. " WHERE accountIdx > 0 AND accountIdx = ". $idx;

		$row = $db->getListSet($query);
		$row->next();

		if ($field) {
			return $row->get($field);
		} else {
			return $row;
		}
	}

	function getBillingUserInfoByParentIdxAndLevel($parentIdx, $level, $field = null) {
		global $db, $M_FUNC;

		$query = " SELECT * "
					. " FROM ". BILLING_TABLE
					. " WHERE parentIdx = ". $parentIdx ." AND level = ". $level;
		$row = $db->getListSet($query);
		$row->next();

		if ($field) {
			return $row->get($field);
		} else {
			return $row;
		}
	}

	function getAccountRoleByAccountIdx($idx, $level) {
		global $db, $M_FUNC;

		$query = " SELECT * "
					. " FROM ". ACCOUNT_ROLE_TABLE
					. " WHERE accountIdx = ". $idx ." AND level = ". $level;
		$row = $db->getListSet($query);
		return $row;
	}

	function getRoleNameByAccountIdx($idx, $level) {
		global $db, $M_FUNC;
		
		$accountRoleRow = $this->getAccountRoleByAccountIdx($idx, $level);
		if($accountRoleRow->size() == 0) {
			return "";
		}
		$accountRoleRow->next();
		$roleIdx = $accountRoleRow->get("roleIdx");
		if ($level == 41) {
			$roleName = $this->getAdvertiserInfoByIdx($roleIdx, "advertiserName");
		} elseif ($level == 21) {
			include_once COMMON_CLASS . "/class.media.php";
			$media = new M_MEDIA;
			$roleName = $media->getMediaInfoByIdx($roleIdx, "mediaName");
		}

		return $roleName;
	}

	function getRequestList(&$total_page, &$NO, &$cnt_no, $addWhere = null, $order = null, $limit = null) {
		global $db, $M_FUNC, $PAGE;

		if ($PAGE < 1 or $PAGE == "") $PAGE = 1;
		$start_row = ($PAGE - 1) * C_LIST_CNT;
		$where = " WHERE 1 = 1 ";
		if ($addWhere) {
			$where .= $addWhere;
		}
		
		if ($order == "") {
			//$orderQuery = " ORDER BY idx DESC ";
			$orderQuery = "";
		} else {
			$orderQuery = " ORDER BY ". $order;
		}
		
		if ($limit == "NO") {
			$limitQuery = "";
		} else {
			$limitQuery = " LIMIT ". $start_row .", ". C_LIST_CNT;
		}

		$query = " SELECT * "
					. " FROM ". ADMINHISTORY_TABLE
					. $where
					. $orderQuery
					. $limitQuery;
		$row = $db->getListSet($query);

		$cnt_no = $db->cnt(ADMINHISTORY_TABLE, $where);
		$total_page = (int)(($cnt_no - 1) / C_LIST_CNT) + 1;
		$NO = $cnt_no - $start_row;
		
		return $row;
	}

	function getRequestList_V2($addWhere = null, $order = null, $limit = null) {
		global $db, $M_FUNC, $PAGE;

		if ($PAGE < 1 or $PAGE == "") $PAGE = 1;
		$start_row = ($PAGE - 1) * C_LIST_CNT;
		$where = " WHERE 1 = 1 ";
		if ($addWhere) {
			$where .= $addWhere;
		}
		
		if ($order == "") {
			//$orderQuery = " ORDER BY idx DESC ";
			$orderQuery = "";
		} else {
			$orderQuery = " ORDER BY ". $order;
		}
		
		if ($limit == "NO") {
			$limitQuery = "";
		} else {
			$limitQuery = " LIMIT ". $start_row .", ". C_LIST_CNT;
		}

		$query = " SELECT * "
					. " FROM ". ADMINHISTORY_TABLE
					. $where
					. $orderQuery
					. $limitQuery;
		$row = $db->getListSet($query);

		$cnt_no = $db->cnt(ADMINHISTORY_TABLE, $where);
		$total_page = (int)(($cnt_no - 1) / C_LIST_CNT) + 1;
		$NO = $cnt_no - $start_row;
		
		return $row;
	}

	function deleteData($m_id) {
		global $db, $M_FUNC, $M_CRUMB, $M_JS, $_SESSION, $M_FILE, $MENU_ID;

		$data = array(
			"status" => "99"
		);

		if (is_array($m_id)) {
			for ($i = 0; $i < count($m_id); $i++) {
				$idx = $m_id[$i];
				$where = " WHERE idx = ". $idx;
				
				if ($_SESSION["permission"] == 1) {
					$db->update($this->table, $data, $where);
				}
			}
		} else {
			$idx = $m_id;

			$where = " WHERE idx = ". $idx;
			if ($_SESSION["permission"] == 1) {
				$db->update($this->table, $data, $where);
			}
		}
	}
} //*** End of Class
?>