<?php
/*********************************************************************
*	Description	:	Class for account page
*	Developer		:	Min (min@minstory.kr / 010.3597.2794)
*	Date				:	2014. 05. 12
*	Have a nice day, Good Luck to you ^^/
*********************************************************************/
if (!class_exists("M_ACCOUNT")) {
	include_once COMMON_CLASS . "/class.account.php";
}

class M_AccountPage extends M_ACCOUNT {

	function __construct() {
		parent::__construct();
	}

	function __destruct() {
	}

	function searchBar($searchType, $searchTxt, $DateYmd = "", $searchLevel = "") {
		global $M_HTML, $M_FUNC, $MENU_ID;

		if($MENU_ID != "M0205") {
			if ($MENU_ID == "M0201") {
				$searchType_arr = array(
					0	=> "Selecting Search Category",
					1	=> "ID",
					2	=> "Name"
				);
			} elseif($MENU_ID == "M0204") {
				$searchType_arr = array(
					0	=> "Selecting Search Category",
					1	=> "ID",
					2	=> "Name",
				);
			}

			$HTML = "<div class=\"sch_box\">"
				
						. "<ul class=\"first\">
							<li><strong>Search</strong>&nbsp;&nbsp;&nbsp;"
								. $M_HTML->_Select("searchType", $searchType_arr, $searchType)
								. $M_HTML->input_Text("searchTxt", urldecode($searchTxt), '', "width:150px; margin-left:5px;", "onkeyup=\"enterEvent();\"")							
						. "</li>
							<li class=\"right\">
								<span id=\"btn_search\" class=\"button large black\"><a hef=\"javascript:void();\">Search</a></span>
							</li>
						</ul>
						<div class=\"clear\"></div>"
						. "</div>";

		} else {
			$DateYmd_1 = $_GET["DateYmd_1"];
			$DateYmd_2 = $_GET["DateYmd_2"];

			if (!$DateYmd_1 ) { $DateYmd_1 = date("Ymd", time()); }
			if (!$DateYmd_2 ) { $DateYmd_2 = date("Ymd", time()); }

			$searchType2 = $M_FUNC->M_Filter(GET, "searchType2");

			$searchType_arr = array(
				0		=> 'Selecting Search Category',
				1		=> 'ID',
				2		=> 'Memo'
			);

			$HTML = "<div class=\"sch_box\">"
						. "<ul class=\"first\">
							<li><strong>Search</strong>&nbsp;&nbsp;&nbsp;"
								. $M_HTML->_Select("searchType", $searchType_arr, $searchType)."&nbsp;"
								. $M_HTML->input_Text("searchTxt", urldecode($searchTxt), '', "width:150px; margin-left:5px;", "onkeyup=\"enterEvent();\"")."&nbsp;&nbsp;Period : "
								. $M_HTML->input_Text("DateYmd_1", $DateYmd_1, '', "width:80px; margin-left:5px;", "onkeyup=\"enterEvent();\"")
								. " ~ "
								. $M_HTML->input_Text("DateYmd_2", $DateYmd_2, '', "width:80px; margin-left:5px;", "onkeyup=\"enterEvent();\"")
						. "</li>
							<li class=\"right\">
								<span id=\"btn_search\" class=\"button large black\"><a hef=\"javascript:void();\">Search</a></span>
							</li>
						  </ul>
							<div class=\"clear\"></div>"
						. "</div>";
		}

		return $HTML;
	}

	/****************************************************************************
	*	Function Name	: accountList()
	*	Description		: Get List for accounts
	*****************************************************************************/
	function accountList() {
		global $MENU_ID, $P_ACTION, $m_id;
		global $M_FUNC, $M_ADMIN, $M_JS, $M_HTML;
		global $MENU_1DEPTH, $MENU_2DEPTH, $PAGE;

		$searchType = $M_FUNC->M_Filter(GET, "searchType");
		$searchTxt = $M_FUNC->M_Filter(GET, "searchTxt");
		$od = $M_FUNC->M_Filter(GET, "od");
		$ot = $M_FUNC->M_Filter(GET, "ot");

		if($od == ""){$od=2;}
		if($ot == ""){$ot=5;}

		$order = "";
		if($ot){
			switch ($ot){
				case 2 : $order_type = ' accountID '; break;
				case 3 : $order_type = ' accountName '; break;
				case 5 : $order_type = ' regUnixtime '; break;
			}

			if($od==1){
				$direction = "&#9652;";
				$order_direction = 'ASC';
			} else {
				$direction = "&#9662;";
				$order_direction = 'DESC';
			}
		}
		$order = $order_type.$order_direction;

		$URLParam = "searchType=". $searchType ."&searchTxt=". $searchTxt . "&searchLevel=". $searchLevel."&od=".$od."&ot=".$ot."";

		if ($searchTxt) {
			if($searchType == 0){
				$where .= " AND (accountID LIKE '%". $searchTxt ."%'  OR accountName LIKE '%". $searchTxt ."%' )";
			} else if ($searchType == 1) {
				$where .= " AND accountID LIKE '%". $searchTxt ."%' ";
			} elseif ($searchType == 2) {
				$where .= " AND accountName LIKE '%". $searchTxt ."%' ";
			}
		}

		$row = $this->getAccountList($total_page, $NO, $cnt_no, $where, $order);

		/*** HTML Part ***/
		include_once ADMIN_PAGE_PATH ."/". $M_FUNC->getPath($MENU_1DEPTH) ."/accountList.html";
	}

	/****************************************************************************
	*	Function Name	: accountRV()
	*	Description		: Regist & View account informations.
	*****************************************************************************/
	function accountRV($mode = "regist") {
		global $MENU_ID, $P_ACTION, $m_id;
		global $M_FUNC, $M_HTML, $M_ADMIN, $M_CRUMB, $M_JS;
		global $MENU_1DEPTH, $MENU_2DEPTH, $PAGE;
		global $DDDCP, $HP_FIRST;

		/*** crumb to session ***/
		$m_crumb = $M_CRUMB->getCrumb();
		$_SESSION["m_crumb"] = $m_crumb;
		
		if ($mode == "view") {
			$m_id = $M_FUNC->M_Filter(GET, "m_id");
			$accountRow = $this->getAccountInfoByIdx($m_id);
				if($accountRow->size() == 0){
				$M_JS->back("존재하지 않는 계정입니다.");
			}
			$userRow = $this->getUserInfoByAccountIdx($m_id);
			$action_url = "?". $MENU_ID ."U";
			
			$accountRoleRow = $this->getAccountRoleByAccountIdx($m_id, $accountRow->get("level"));
			$accountRoleRow->next();
			$accountLevel = $accountRow->get("level");
		} else {
			$accountRow = new L_ListSet();
			$userRow = new L_ListSet();
			$action_url = "?". $MENU_ID ."P";
			$accountRoleRow = new L_ListSet();

			$accountLevel = 2;
		}

		/*** HTML Part ***/
		include_once ADMIN_PAGE_PATH ."/". $M_FUNC->getPath($MENU_1DEPTH) ."/accountRV.html";
	}

	/****************************************************************************
	*	Function Name	: accountDataUpdateProc()
	*	Description		: Update Processing Function
	*****************************************************************************/
	function accountDataUpdateProc() {
		global $MENU_ID, $P_ACTION, $m_id;
		global $M_FUNC, $M_HTML, $M_ADMIN,$M_JS;

		$m_id = $M_FUNC->M_Filter(POST, "m_id");
		$accountName	= $M_FUNC->M_Filter(POST, "accountName");
		$this->updateAccountData();

		$M_ADMIN->recordActionLog("U", $MENU_ID, $m_id, "[".$accountName."] Edit account");

		$M_JS->replace_URL("/?". $MENU_ID . "V&m_id=". $m_id, "It is changed.", "parent");
	}

	/****************************************************************************
	*	Function Name	: accountDataInsertProc()
	*	Description		: Insert Processing Function
	*****************************************************************************/
	function accountDataInsertProc() {
		global $MENU_ID, $P_ACTION, $m_id;
		global $M_FUNC, $M_HTML, $M_ADMIN,$M_JS;
		global $MENU_1DEPTH, $MENU_2DEPTH, $PAGE;
		global $M_CRUMB, $_SESSION;

		$accountName	= $M_FUNC->M_Filter(POST, "accountName");
		$accountIdx = $this->insertAccountData();

		$M_ADMIN->recordActionLog("P", $MENU_ID, $accountIdx, "[".$accountName."] Register account");

		$M_JS->replace_URL($M_ADMIN->ADMIN_MENU[2]['subMenu'][1]['linkURL'], "Registered.", "parent");
	}

	/****************************************************************************
	*	Function Name	: accountDataDeleteProc2017-06-27()
	*	Description		: Delete processing Function
	*****************************************************************************/
	function accountDataDeleteProc() {
		global $MENU_ID, $P_ACTION, $m_id;
		global $M_FUNC, $M_HTML, $M_ADMIN, $M_SIGNUP, $M_JS;
		global $MENU_1DEPTH, $MENU_2DEPTH, $PAGE;
		global $M_CRUMB, $_SESSION;

		$m_id = $M_FUNC->M_Filter(POST, "m_id");
		$accountName	= $M_FUNC->M_Filter(POST, "accountName");
		$this->table = ACCOUNT_TABLE;
		$this->deleteData($m_id);

		$M_ADMIN->recordActionLog("D", $MENU_ID, $m_id, "[".$accountName."] Delete account");

		$M_JS->replace_URL($M_ADMIN->ADMIN_MENU[2]['subMenu'][1]['linkURL'], "Removed.", "parent");
	}

	/****************************************************************************
	*	Function Name	: advertiserList()
	*	Description		: Get List for agency
	*****************************************************************************/
	function advertiserList() {
		global $MENU_ID, $P_ACTION, $m_id;
		global $M_FUNC, $M_ADMIN, $M_JS, $M_HTML;
		global $MENU_1DEPTH, $MENU_2DEPTH, $PAGE;

		$od = $M_FUNC->M_Filter(GET, "od");
		$ot = $M_FUNC->M_Filter(GET, "ot");
		$searchType = $M_FUNC->M_Filter(GET, "searchType");
		$searchTxt = $M_FUNC->M_Filter(GET, "searchTxt");

		if($od == ""){$od=2;}
		if($ot == ""){$ot=4;}

		$order = "";
		if($ot){
			switch ($ot){
				case 2 : $order_type = ' ad.advertiserName '; break;
				case 3 : $order_type = ' ai.accountID '; break;
				case 4 : $order_type = ' regUnixtime '; break;
			}

			if($od==1){
				$direction = "&#9652;";
				$order_direction = 'ASC';
			} else {
				$direction = "&#9662;";
				$order_direction = 'DESC';
			}
		}
		$order = $order_type.$order_direction;

		if ($searchTxt) {
			if ($searchType == 0){
				$where .= " AND (ad.advertiserName LIKE '%". $searchTxt ."%' OR ai.accountID LIKE '%". $searchTxt ."%' ) ";
			} elseif($searchType == 1) {
				$where .= " AND ai.accountID LIKE '%". $searchTxt ."%' ";
			} elseif($searchType == 2) {
				$where .=" AND ad.advertiserName LIKE '%". $searchTxt ."%' ";
			}
		}

		$URLParam = "searchType=". $searchType ."&searchTxt=". $searchTxt."&od=".$od."&ot=".$ot."";

		$row = $this->getAdvertiserRow($total_page, $NO, $cnt_no,$where,$order);
		$accountRow = $this->getAccountIdArr();

		/*** HTML Part ***/
		include_once ADMIN_PAGE_PATH ."/". $M_FUNC->getPath($MENU_1DEPTH) ."/advertiserList.html";
	}

	/****************************************************************************
	*	Function Name	: advertiserRV()
	*	Description		: Regist & View partner informations.
	*****************************************************************************/
	function advertiserRV($mode = "regist") {
		global $MENU_ID, $P_ACTION, $m_id;
		global $M_FUNC, $M_HTML, $M_ADMIN, $M_CRUMB, $M_JS;
		global $MENU_1DEPTH, $MENU_2DEPTH, $PAGE;
		global $DDDCP, $HP_FIRST;

		/*** crumb to session ***/
		$m_crumb = $M_CRUMB->getCrumb();
		$_SESSION["m_crumb"] = $m_crumb;
		
		if ($mode == "view") {
			$m_id = $M_FUNC->M_Filter(GET, "m_id");
			$advertiserRow = $this->getAdvertiserInfoByIdx($m_id);
			if($advertiserRow->size() == 0){
				$M_JS->back("존재하지 않는 계정입니다.");
			}
			$accountRow = $this->getAccountInfoByIdx($advertiserRow->get("keyAccountIdx"));
			$userRow = $this->getUserInfoByAccountIdx($advertiserRow->get("keyAccountIdx"));
			$action_url = "?". $MENU_ID ."U";

		} else {
			$advertiserRow = new L_ListSet();
			$accountRow = new L_ListSet();
			$userRow = new L_ListSet();
			$action_url = "?". $MENU_ID ."P";


		}
		
		/*** HTML Part ***/
		include_once ADMIN_PAGE_PATH ."/". $M_FUNC->getPath($MENU_1DEPTH) ."/advertiserRV.html";
	}

	/****************************************************************************
	*	Function Name	: advertiserDataUpdateProc()
	*	Description		: Update processing Function
	*****************************************************************************/
	function advertiserDataUpdateProc() {
		global $MENU_ID, $P_ACTION, $m_id;
		global $M_FUNC, $M_HTML, $M_ADMIN, $M_SIGNUP, $M_JS;

		$m_id = $M_FUNC->M_Filter(POST, "m_id");
		$advertiserName	= $M_FUNC->M_Filter(POST, "advertiserName");
		$this->updateAdvertiserData();

		$M_ADMIN->recordActionLog("U", $MENU_ID, $m_id, "[".$advertiserName."] Advertiser changed");

		$M_JS->Go_URL("/?". $MENU_ID . "V&m_id=". $m_id, "It is changed.", "parent");
	}

	/****************************************************************************
	*	Function Name	: advertiserDataInsertProc()
	*	Description		: Insert processing Function
	*****************************************************************************/
	function advertiserDataInsertProc() {
		global $MENU_ID, $P_ACTION, $m_id;
		global $M_FUNC, $M_HTML, $M_ADMIN, $M_SIGNUP, $M_JS;
		global $MENU_1DEPTH, $MENU_2DEPTH, $PAGE;
		global $M_CRUMB, $_SESSION;

		$advertiserName	= $M_FUNC->M_Filter(POST, "advertiserName");
		$advertiserIdx = $this->insertAdvertiserData();

		$M_ADMIN->recordActionLog("P", $MENU_ID, $advertiserIdx, "[".$advertiserName."] Advertiser Registered");

		$M_JS->replace_URL($M_ADMIN->ADMIN_MENU[2]['subMenu'][4]['linkURL'], "Registered.", "parent");
	}

	/****************************************************************************
	*	Function Name	: advertiserDataDeleteProc()
	*	Description		: Delete processing Function
	*****************************************************************************/
	function advertiserDataDeleteProc() {
		global $MENU_ID, $P_ACTION, $m_id;
		global $M_FUNC, $M_HTML, $M_ADMIN, $M_SIGNUP, $M_JS;
		global $MENU_1DEPTH, $MENU_2DEPTH, $PAGE;
		global $M_CRUMB, $_SESSION;

		$m_id = $M_FUNC->M_Filter(POST, "m_id");
		$advertiserName	= $M_FUNC->M_Filter(POST, "advertiserName");
		$this->table = ADVERTISER_TABLE;
		$this->deleteData($m_id);

		$M_ADMIN->recordActionLog("D", $MENU_ID, $m_id, "[".$advertiserName."] Advertiser Delete");

		$M_JS->Go_URL($M_ADMIN->ADMIN_MENU[2]['subMenu'][4]['linkURL'], "Removed.", "parent");
	}

	/****************************************************************************
	*	Function Name	:	()
	*	Description		: Get List for accounts
	*****************************************************************************/
	function requestList() {
		global $MENU_ID, $P_ACTION, $m_id, $db;
		global $M_FUNC, $M_ADMIN, $M_JS, $M_HTML;
		global $MENU_1DEPTH, $MENU_2DEPTH, $PAGE;
		//global $DateYmd_1, $DateYmd_2, $searchType, $searchType2, $searchTxt;

		$DateYmd_1 = $M_FUNC->M_Filter(GET, "DateYmd_1");
		$DateYmd_2 = $M_FUNC->M_Filter(GET, "DateYmd_2");
		$searchType = $M_FUNC->M_Filter(GET, "searchType");
		//$searchType2 = $M_FUNC->M_Filter(GET, "searchType2");
		$searchTxt = $M_FUNC->M_Filter(GET, "searchTxt");
		$od = $M_FUNC->M_Filter(GET, "od");
		$ot = $M_FUNC->M_Filter(GET, "ot");

		if($od == ""){$od=2;}
		if($ot == ""){$ot=7;}

		if($od==1){
			$direction = "&#9652;";
		} else {
			$direction = "&#9662;";
		}

		if ($searchTxt) {
			if ($searchType == 0){
				$where .= " AND (accountID like '%". $searchTxt ."%' OR memo like '%". $searchTxt ."%')";
			} elseif ($searchType == 1) {
				$where .= " AND accountID like '%". $searchTxt ."%' ";
			} elseif ($searchType == 2) {
				$where .= " AND memo like '%". $searchTxt ."%' ";
			}
		}

		if ($DateYmd_1 && $DateYmd_2) {
			$DateYMD2_END = date("Ymd", strtotime($DateYmd_2."+1 days"));
			$where .= " AND dateYmd between '".$DateYmd_1."' and '".$DateYMD2_END."' ";
		} else {
			$where .= " AND dateYmd =".date("Ymd", time())." ";
		}

		$URLParam = "searchType=". $searchType ."&searchType2=". $searchType2 ."&searchTxt=". $searchTxt . "&DateYmd_1=". $DateYmd_1 ."&DateYmd_2=".$DateYmd_2."&od=".$od."&ot=".$ot."";

		include_once COMMON_CLASS . "/class.media.php";
		$M_MEDIA = new M_MEDIA;
		include_once COMMON_CLASS . "/class.ad.php";
		$M_AD = new M_AD;

		$result = array();
		$arr_key = array();
		$row = $this->getRequestList_V2($where,"","NO");
		
		for($i=0;$i<$row->size();$i++){
			$row->next();
			
			switch($row->get("action")) {
				case "1"		: $result[$i]['action'] = "Regist";			break;
				case "2"		: $result[$i]['action'] = "Modify";			break;
				case "3"		: $result[$i]['action'] = "Delete";			break;
				case "9"		: $result[$i]['action'] = "Login";		break;
				case "11"		: $result[$i]['action'] = "Add Link";		break;
				case "13"		: $result[$i]['action'] = "Delete Link";		break;
				default			: $result[$i]['action'] = "ETC";			break;
			}
			
			$result[$i]["pageNo"] = "";
			if($row->get("MENU_ID") == "login") {
				$result[$i]['pageName'] = $row->get("MENU_ID");
			} else if(substr($row->get("MENU_ID"), 0, 1) == "M") {
				$result[$i]['pageName'] = $M_ADMIN->ADMIN_MENU[substr($row->get("MENU_ID"), 2, 1)]['name']." &gt; ".$M_ADMIN->ADMIN_MENU[substr($row->get("MENU_ID"), 2, 1)]['subMenu'][substr($row->get("MENU_ID"), 4, 1)]['name'];
				
				if(intval($row->get("m_id")) > 0){
					switch(substr($row->get("MENU_ID"), 0, 5)) {
						case "M0201" : $row2 = $this->getAccountInfoByIdx($row->get("m_id"));				break;
						case "M0204" : $row2 = $this->getAdvertiserInfoByIdx($row->get("m_id"));			break;
						case "M0301" : $row2 = $M_MEDIA->getMediaInfoByIdx($row->get("m_id"));			break;
						case "M0302" : $row2 = $M_MEDIA->getPageDataByIdx($row->get("m_id"));			break;
						case "M0303" : $row2 = $M_MEDIA->getSlotDataByIdx($row->get("m_id"));			break;
						case "M0304" : $row2 = $M_MEDIA->getTemplateDataByIdx($row->get("m_id"));	break;
						case "M0305" : $row2 = $M_MEDIA->getSlotGroupInfoByIdx($row->get("m_id"));	break;
						case "M0401" : $row2 = $M_AD->getSiteInfoByIdx($row->get("m_id"));					break;
						case "M0402" : $row2 = $M_AD->getCampaignDataByIdx($row->get("m_id"));		break;
					}

					if ($row2) {
						$result[$i]["pageNo"] = $row2->get("logName") . " (".$row->get("m_id").")";
					} else {
						$result[$i]["pageNo"] = $row->get("m_id");
					}
				}
			}
			if($row->get("pType")==1){	
				$result[$i]["pType"] = "admin";	
			}else{	
				$result[$i]["pType"] = "ncs";
			}

			$result[$i]['accountID'] = $row->get("accountID");
			$result[$i]['user_ip'] = $row->get("user_ip");
			$result[$i]['memo'] = $row->get("memo");
			$result[$i]['regUnixtime'] = date("Y.m.d H:i", $row->get("regUnixtime"));

			switch($ot) {
				case 1 : $arr_key[] = $row->get('accountID'); break;
				case 2 : $arr_key[] = $result[$i]['action']; break;
				case 7 : $arr_key[] = $row->get("regUnixtime"); break;
			}
		}

		if(count($arr_key) > 0) {
			if($od == 1) {
				array_multisort($arr_key, SORT_ASC, $result);
			} else {
				array_multisort($arr_key, SORT_DESC, $result);
			}
		}
		/*** HTML Part ***/
		include_once ADMIN_PAGE_PATH ."/". $M_FUNC->getPath($MENU_1DEPTH) ."/requestList.html";
	}
} //*** End of Class

?>

